pipeline {
  agent any


    environment {
      registry = 'gitlab.com/nattha.u/simple-spring-restful-app'
      //registryCredential = 'jenkinsdocker'
      //pipelineGitCredential = 'gitlab-pipeline-token'
      //pipelineGitUrl = 'git.g-able.com/baaclos/pipeline-cicd.git'
      dockerImage = ''
      appName = ''
      currentPomVersion = ''
      newVersion = ''
    }
  stages {
    stage('Prepare configuration') {
        steps {
            script {
                

                sh "git clone https://${pipelineGitUrl}"
                sh "cp -a pipeline-cicd/springboot/dev/. ."
                sh 'rm -rf pipeline-cicd'

                //gitUrl =  scm.getUserRemoteConfigs()[0].getUrl().substring(8)
                def pom = readMavenPom file: 'pom.xml'
                appName = pom.name   
                // def props = readProperties  file: 'src/main/resources/application.properties'

                def (major, miner, build) = pom.version.tokenize('.')
                currentPomVersion = "${major}.${miner}.${build}"
                newVersion = "${major}.${miner}." + (build.toInteger() + 1)

                sh "sed -i \'0,/${currentPomVersion}/s//${newVersion}/\' pom.xml"

                // authorName = sh (
                //     script: 'git --no-pager show -s --format=\'%an\'',
                //     returnStdout: true
                // ).trim()

                // authorEmail = sh (
                //     script: 'git --no-pager show -s --format=\'%ae\'',
                //     returnStdout: true
                // ).trim()
            }
        }
        
    }
    

    stage('Build') { 
        steps {
            script {
                
                    dockerImage = docker.build appName + ":${newVersion}"
                
            }
        }        
    }

  }

}